/**
 * @fileOverview Kickass library to create and place poppers near their reference elements.
 * @version 0.3.2
 * @license
 * Copyright (c) 2016 Federico Zivolo and contributors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
!function(a,b){"function"==typeof define&&define.amd?define(b):"object"==typeof module&&module.exports?module.exports=b():a.Popper=b()}(this,function(){"use strict";function a(a,b,c){this._trigger=a,this.state={};var d="undefined"==typeof b||null===b,e=b&&"Object"===b.constructor.name;d||e?this._popper=this.parse(e?b:{}):this._popper=b,this._options=Object.assign({},q,c),this._options.modifiers=this._options.modifiers.map(function(a){if("string"==typeof a){if(-1!==this._options.modifiersIgnored.indexOf(a))return;return this.modifiers[a]}return a}.bind(this)),-1!==this._options.modifiers.indexOf("applyStyle")&&this._popper.setAttribute("x-placement",this._options.placement),this.update(),this._setupEventListeners()}function b(a){var b=p.getComputedStyle(a),c=parseFloat(b.marginTop)+parseFloat(b.marginBottom),d=parseFloat(b.marginLeft)+parseFloat(b.marginRight);return{width:a.offsetWidth+d,height:a.offsetHeight+c}}function c(a){var b={left:"right",right:"left",bottom:"top",top:"bottom"};return a.replace(/left|right|bottom|top/g,function(a){return b[a]})}function d(a){var b=Object.assign({},a);return b.right=b.left+b.width,b.bottom=b.top+b.height,b}function e(a,b){var c,d=0;for(c in a){if(a[c]===b)return d;d++}return null}function f(a,b){var c=p.getComputedStyle(a,null);return c[b]}function g(a){return a.offsetParent!==p.document.body&&a.offsetParent?a.offsetParent:p.document.documentElement}function h(a){return a===p.document?p.document.body.scrollTop?p.document.body:p.document.documentElement:-1!==["scroll","auto"].indexOf(f(a,"overflow"))||-1!==["scroll","auto"].indexOf(f(a,"overflow-x"))||-1!==["scroll","auto"].indexOf(f(a,"overflow-y"))?a:a.parentNode?h(a.parentNode):a}function i(a){return a===p.document.body?!1:"fixed"===f(a,"position")?!0:a.parentNode?i(a.parentNode):a}function j(a,b){function c(a){return""!==a&&!isNaN(parseFloat(a))&&isFinite(a)}Object.keys(b).forEach(function(d){var e="";-1!==["width","height","top","right","bottom","left"].indexOf(d)&&c(b[d])&&(e="px"),a.style[d]=b[d]+e})}function k(a){var b={};return a&&"[object Function]"===b.toString.call(a)}function l(a){var b={width:a.offsetWidth,height:a.offsetHeight,left:a.offsetLeft,top:a.offsetTop};return b.right=b.left+b.width,b.bottom=b.top+b.height,b}function m(a){var b=a.getBoundingClientRect();return{left:b.left,top:b.top,right:b.right,bottom:b.bottom,width:b.right-b.left,height:b.bottom-b.top}}function n(a,b,c){var d=m(a),e=m(b);if(c){var f=h(b);e.top+=f.scrollTop,e.bottom+=f.scrollTop,e.left+=f.scrollLeft,e.right+=f.scrollLeft}var g={top:d.top-e.top,left:d.left-e.left,bottom:d.top-e.top+d.height,right:d.left-e.left+d.width,width:d.width,height:d.height};return g}function o(a){for(var b=["","ms","webkit","moz","o"],c=0;c<b.length;c++){var d=b[c]?b[c]+a.charAt(0).toUpperCase()+a.slice(1):a;if("undefined"!=typeof p.document.body.style[d])return d}return null}var p=window,q={placement:"bottom",gpuAcceleration:!0,offset:0,boundariesElement:"viewport",boundariesPadding:5,preventOverflowOrder:["left","right","top","bottom"],flipBehavior:"flip",arrowElement:"[x-arrow]",modifiers:["shift","offset","preventOverflow","keepTogether","arrow","flip","applyStyle"],modifiersIgnored:[]};a.prototype.destroy=function(){this._popper.removeAttribute("x-placement"),this._popper.style.left="",this._popper.style.position="",this._popper.style.top="",this._popper.style[o("transform")]="",this._removeEventListeners()},a.prototype.update=function(){var a={};a.placement=this._options.placement,a._originalPlacement=this._options.placement,a.offsets=this._getOffsets(this._popper,this._trigger,a.placement),a.boundaries=this._getBoundaries(a,this._options.boundariesPadding,this._options.boundariesElement),a=this.runModifiers(a,this._options.modifiers),"function"==typeof this.state.updateCallback&&this.state.updateCallback(a)},a.prototype.onCreate=function(a){a(this)},a.prototype.onUpdate=function(a){this.state.updateCallback=a},a.prototype.parse=function(a){function b(a,b){b.forEach(function(b){a.classList.add(b)})}function c(a,b){b.forEach(function(b){a.setAttribute(b.split(":")[0],b.split(":")[1])})}var d={tagName:"div",classNames:["popper"],attributes:[],parent:p.document.body,content:"",allowHtml:!1,arrow:{tagName:"div",classNames:["popper__arrow"],attributes:["x-arrow"]}};a=Object.assign({},d,a);var e=p.document,f=e.createElement(a.tagName);if(b(f,a.classNames),c(f,a.attributes),a.allowHtml?f.innerHTML=a.content:f.textContent=a.content,a.arrow){var g=e.createElement(a.arrow.tagName);b(g,a.arrow.classNames),c(g,a.arrow.attributes),f.appendChild(g)}var h=a.parent;if("string"==typeof h){if(h=e.querySelectorAll(a.parent),h.length>1&&console.warning("WARNING: the given `parent` query("+a.parent+") matched more than one element, the first one will be used"),0===h.length)throw"ERROR: the given `parent` doesn't exists!";h=h[0]}return h.length>1&&(console.warning("WARNING: you have passed as parent a list of elements, the first one will be used"),h=h[0]),h.appendChild(f),f},a.prototype._getOffsets=function(a,c,d){d=d.split("-")[0];var e={},f=g(c),h=i(c,f);e.position=h?"fixed":"absolute",this.state.position=e.position;var j=n(c,g(a),h),k=b(a);return-1!==["right","left"].indexOf(d)?(e.top=j.top+j.height/2-k.height/2,"left"===d?e.left=j.left-k.width:e.left=j.right):(e.left=j.left+j.width/2-k.width/2,"top"===d?e.top=j.top-k.height:e.top=j.bottom),e.width=k.width,e.height=k.height,{popper:e,trigger:j}};var r=null;return a.prototype._setupEventListeners=function(){if(r=this.update.bind(this),p.addEventListener("resize",r),"window"!==this._options.boundariesElement){var a=h(this._trigger);a!==p.document.body&&a!==p.document.documentElement||(a=p),a.addEventListener("scroll",r)}},a.prototype._removeEventListeners=function(){if(p.removeEventListener("resize",r),"window"!==this._options.boundariesElement){var a=h(this._trigger);a!==p.document.body&&a!==p.document.documentElement||(a=p),a.removeEventListener("scroll",r)}r=null},a.prototype._getBoundaries=function(a,b,c){var d,e,f={};if("window"===c){var i=p.document.body,j=p.document.documentElement;e=Math.max(i.scrollHeight,i.offsetHeight,j.clientHeight,j.scrollHeight,j.offsetHeight),d=Math.max(i.scrollWidth,i.offsetWidth,j.clientWidth,j.scrollWidth,j.offsetWidth),f={top:0,right:d,bottom:e,left:0}}else if("viewport"===c){var k=g(this._popper),m=h(this._popper),n=l(k);f={top:0-(n.top-m.scrollTop),right:p.document.documentElement.clientWidth-n.left,bottom:p.document.documentElement.clientHeight-(n.top-m.scrollTop),left:0-n.left}}else f=g(this._popper)===c?{top:0,left:0,right:c.clientWidth,bottom:c.clientHeight}:l(c);return f.left+=b,f.right-=b,f.top=f.top+b,f.bottom=f.bottom-b,f},a.prototype.runModifiers=function(a,b,c){var d=b.slice();return void 0!==c&&(d=this._options.modifiers.slice(0,e(this._options.modifiers,c))),d.forEach(function(b){k(b)&&(a=b.call(this,a))}.bind(this)),a},a.prototype.isModifierRequired=function(a,b){var c=e(this._options.modifiers,a);return!!this._options.modifiers.slice(0,c).filter(function(a){return a===b}).length},a.prototype.modifiers={},a.prototype.modifiers.applyStyle=function(a){var b,c={position:a.offsets.popper.position},d=Math.round(a.offsets.popper.left),e=Math.round(a.offsets.popper.top);return this._options.gpuAcceleration&&(b=o("transform"))?(c[b]="translate3d("+d+"px, "+e+"px, 0)",c.top=0,c.left=0):(c.left=d,c.top=e),j(this._popper,c),this._popper.setAttribute("x-placement",a.placement),this.isModifierRequired(this.modifiers.applyStyle,this.modifiers.arrow)&&a.offsets.arrow&&j(a.arrowElement,a.offsets.arrow),a},a.prototype.modifiers.shift=function(a){var b=a.offsets.trigger,c=d(a.offsets.popper),e=a.placement,f=e.split("-")[1];if(!f)return a;var g={y:{start:b.top,end:b.top+b.height-c.height},x:{start:b.left,end:b.left+b.width-c.width}},h={bottom:function(){return{left:g.x[f]}},top:function(){return{left:g.x[f]}},left:function(){return{top:g.y[f]}},right:function(){return{top:g.y[f]}}};return c=Object.assign(c,h[e.split("-")[0]]()),a.offsets.popper=c,a},a.prototype.modifiers.preventOverflow=function(a){var b=this._options.preventOverflowOrder,c=d(a.offsets.popper),e={left:function(){var b=c.left;return c.left<a.boundaries.left&&(b=Math.max(c.left,a.boundaries.left)),{left:b}},right:function(){var b=c.left;return c.right>a.boundaries.right&&(b=Math.min(c.left,a.boundaries.right-c.width)),{left:b}},top:function(){var b=c.top;return c.top<a.boundaries.top&&(b=Math.max(c.top,a.boundaries.top)),{top:b}},bottom:function(){var b=c.top;return c.bottom>a.boundaries.bottom&&(b=Math.min(c.top,a.boundaries.bottom-c.height)),{top:b}}};return b.forEach(function(b){a.offsets.popper=Object.assign(c,e[b]())}),a},a.prototype.modifiers.keepTogether=function(a){var b=d(a.offsets.popper),c=a.offsets.trigger,e=Math.floor;return b.right<e(c.left)&&(a.offsets.popper.left=e(c.left)-b.width),b.left>e(c.right)&&(a.offsets.popper.left=e(c.right)),b.bottom<e(c.top)&&(a.offsets.popper.top=e(c.top)-b.height),b.top>e(c.bottom)&&(a.offsets.popper.top=e(c.bottom)),a},a.prototype.modifiers.flip=function(a){if(!this.isModifierRequired(this.modifiers.flip,this.modifiers.preventOverflow))return console.warn("WARNING: preventOverflow modifier is required by flip modifier in order to work, be sure to include it before flip!"),a;if(a.flipped&&a.placement===a._originalPlacement)return a;var b=a.placement.split("-")[0],e=c(b),f=a.placement.split("-")[1]||"",g=[];return g="flip"===this._options.flipBehavior?[b,e]:this._options.flipBehavior,g.forEach(function(h,i){if(b===h&&g.length!==i+1){b=a.placement.split("-")[0],e=c(b);var j=d(a.offsets.popper),k=-1!==["right","bottom"].indexOf(b);(k&&Math.floor(a.offsets.trigger[b])>Math.floor(j[e])||!k&&Math.floor(a.offsets.trigger[b])<Math.floor(j[e]))&&(a.flipped=!0,a.placement=g[i+1],f&&(a.placement+="-"+f),a.offsets.popper=this._getOffsets(this._popper,this._trigger,a.placement).popper,a=this.runModifiers(a,this._options.modifiers,this._flip))}}.bind(this)),a},a.prototype.modifiers.offset=function(a){var b=this._options.offset,c=a.offsets.popper;return-1!==a.placement.indexOf("left")?c.top-=b:-1!==a.placement.indexOf("right")?c.top+=b:-1!==a.placement.indexOf("top")?c.left-=b:-1!==a.placement.indexOf("bottom")&&(c.left+=b),a},a.prototype.modifiers.arrow=function(a){var c=this._options.arrowElement;if("string"==typeof c&&(c=this._popper.querySelector(c)),!c)return a;if(!this._popper.contains(c))return console.warn("WARNING: `arrowElement` must be child of its popper element!"),a;if(!this.isModifierRequired(this.modifiers.arrow,this.modifiers.keepTogether))return console.warn("WARNING: keepTogether modifier is required by arrow modifier in order to work, be sure to include it before arrow!"),a;var e,f={},g=a.placement.split("-")[0],h=d(a.offsets.popper),i=a.offsets.trigger,j=-1!==["left","right"].indexOf(g);if(j){var k=b(c).height;i.bottom-k<h.top&&(a.offsets.popper.top-=h.top-(i.bottom-k)),i.top+k>h.bottom&&(a.offsets.popper.top+=i.top+k-h.bottom),e=i.top+i.height/2-k/2;var l=e-h.top;l=Math.max(Math.min(h.height-k,l),0),f.top=l,f.left=""}else{var m=b(c).width;i.right-m<h.left&&(a.offsets.popper.left-=h.left-(i.right-m)),i.left+m>h.right&&(a.offsets.popper.left+=i.left+m-h.right),e=i.left+i.width/2-m/2;var n=e-h.left;n=Math.max(Math.min(h.width-m,n),0),f.left=n,f.top=""}return a.offsets.arrow=f,a.arrowElement=c,a},Object.assign||Object.defineProperty(Object,"assign",{enumerable:!1,configurable:!0,writable:!0,value:function(a){if(void 0===a||null===a)throw new TypeError("Cannot convert first argument to object");for(var b=Object(a),c=1;c<arguments.length;c++){var d=arguments[c];if(void 0!==d&&null!==d){d=Object(d);for(var e=Object.keys(d),f=0,g=e.length;g>f;f++){var h=e[f],i=Object.getOwnPropertyDescriptor(d,h);void 0!==i&&i.enumerable&&(b[h]=d[h])}}}return b}}),a});
//# sourceMappingURL=popper.min.js.map
